//*****************************************************************************
//
// File Name   : project.h (main header file for the ATmega88 PV diversion controller) 
// Author      : D. Festing
// Created     : 09/11/2018
// Revised     : 
// Version     : 1.0
// Target MCU  : Atmega88
// Editor Tabs	: 
//
// Description : This include file contains all #defines, enums and
//               #includes for this project
//
//*****************************************************************************


#ifndef PROJECT_H
#define PROJECT_H


#include <avr/io.h> 
#include <util/delay.h>
//#include <avr/interrupt.h>
#include <util/atomic.h>
#include <avr/wdt.h>


// LED #defines
#define RED_LED_DDR DDRD
#define RED_LED_PORT PORTD
#define RED_LED_DATA_BIT PD5
	
#define GREEN_LED_DDR DDRD
#define GREEN_LED_PORT PORTD
#define GREEN_LED_DATA_BIT PD2

// Bit #defines
#define BIT_0 (uint8_t)(1 << 0)
#define BIT_1 (uint8_t)(1 << 1)
#define BIT_2 (uint8_t)(1 << 2)
#define BIT_3 (uint8_t)(1 << 3)
#define BIT_4 (uint8_t)(1 << 4)
#define BIT_5 (uint8_t)(1 << 5)
#define BIT_6 (uint8_t)(1 << 6)
#define BIT_7 (uint8_t)(1 << 7)


// ADC #defines   
#define ADC_ON  (ADCSRA |= (1<<ADEN))
#define ADC_OFF (ADCSRA &= ~(1<<ADEN))
   
//   #define ADC_SELECT_CHANNEL0 do{ADMUX &= ~((1<<MUX3) | (1<<MUX2) | (1<<MUX1) | (1<<MUX0));}while(0)
//   #define ADC_SELECT_CHANNEL1 do{ADMUX &= ~((1<<MUX3) | (1<<MUX2) | (1<<MUX1)); ADMUX |= (1<<MUX0);}while(0)
//   #define ADC_SELECT_CHANNEL2 do{ADMUX &= ~((1<<MUX3) | (1<<MUX2) | (1<<MUX0)); ADMUX |= (1<<MUX1);}while(0)
//   #define ADC_SELECT_CHANNEL3 do{ADMUX &= ~((1<<MUX3) | (1<<MUX2)); ADMUX |= ((1<<MUX1) | (1<<MUX0));}while(0)
#define ADC_SELECT_CHANNEL4 do{ADMUX &= ~((1<<MUX3) | (1<<MUX1) | (1<<MUX0)); ADMUX |= (1<<MUX2);}while(0)
//   #define ADC_SELECT_CHANNEL5 do{ADMUX &= ~((1<<MUX3) | (1<<MUX1)); ADMUX |= ((1<<MUX2) | (1<<MUX0));}while(0)
//   #define ADC_SELECT_CHANNEL6 do{ADMUX &= ~((1<<MUX3) | (1<<MUX0)); ADMUX |= ((1<<MUX2) | (1<<MUX1));}while(0)
//   #define ADC_SELECT_CHANNEL7 do{ADMUX &= ~(1<<MUX3); ADMUX |= ((1<<MUX2) | (1<<MUX1)| (1<<MUX0));}while(0)

// number of ADC samples to average   
#define NUMBER_OF_SAMPLES 8
 
// utility #defines
#define FOREVER for(;;)
#define _NOP() do { __asm__ __volatile__ ("nop"); } while (0)
// approximately an 2us delay with a 16MHz xtal
  
typedef enum {FALSE = 0, TRUE = 1}bool_t;

#endif
